---
title: BaseAudioContext.createPeriodicWave()
slug: Web/API/BaseAudioContext/createPeriodicWave
tags:
  - API
  - Audio
  - AudioContext
  - BaseAudioContext
  - Media
  - Method
  - Reference
  - Web Audio API
  - createPeriodicWave
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p><span class="seoSummary">The <code>createPeriodicWave()</code> method of the {{ domxref("BaseAudioContext") }} Interface is used to create a {{domxref("PeriodicWave")}}, which is used to define a periodic waveform that can be used to shape the output of an {{ domxref("OscillatorNode") }}.</span></p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var wave = <em>AudioContext</em>.createPeriodicWave(<em>real</em>, <em>imag</em>[, <em>constraints</em>]);</pre>

<h3 id="Returns">Returns</h3>

<p>A {{domxref("PeriodicWave")}}.</p>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code>real</code></dt>
	<dd>An array of cosine terms (traditionally the A terms).</dd>
	<dt><code>imag</code></dt>
	<dd>An array of sine terms (traditionally the B terms).</dd>
</dl>

<p>The <code>real</code> and <code>imag</code> arrays have to have the same length, otherwise an error is thrown.</p>

<dl>
	<dt><code>constraints</code> {{optional_inline}}</dt>
	<dd>An dictionary object that specifies whether normalization should be disabled (if not specified, normalization is enabled by default.) It takes one property:
	<ul>
		<li><code>disableNormalization</code>: If set to <code>true</code>, normalization is disabled for the periodic wave. The default is <code>false</code>.</li>
	</ul>
	</dd>
</dl>

<div class="note">
<p>If normalized, the resulting wave will have a maximum absolute peak value of 1.</p>
</div>

<h2 id="Example">Example</h2>

<p>The following example illustrates simple usage of <code>createPeriodicWave()</code>, to create a {{domxref("PeriodicWave")}} object containing a simple sine wave.</p>

<pre class="brush: js">var real = new Float32Array(2);
var imag = new Float32Array(2);
var ac = new AudioContext();
var osc = ac.createOscillator();

real[0] = 0;
imag[0] = 0;
real[1] = 1;
imag[1] = 0;

var wave = ac.createPeriodicWave(real, imag, {disableNormalization: true});

osc.setPeriodicWave(wave);

osc.connect(ac.destination);

osc.start();
osc.stop(2);</pre>

<p>This works because a sound that contains only a fundamental tone is by definition a sine wave</p>

<p>Here, we create a <code>PeriodicWave</code> with two values. The first value is the DC offset, which is the value at which the oscillator starts. 0 is good here, because we want to start the curve at the middle of the [-1.0; 1.0] range.</p>

<p>The second and subsequent values are sine and cosine components. You can think of it as the result of a Fourier transform, where you get frequency domain values from time domain value. Here, with <code>createPeriodicWave()</code>, you specify the frequencies, and the browser performs an inverse Fourier transform to get a time domain buffer for the frequency of the oscillator. Here, we only set one component at full volume (1.0) on the fundamental tone, so we get a sine wave.</p>

<p>The coefficients of the Fourier transform should be given in <em>ascending</em> order (i.e. <math><semantics><mrow><mrow><mo>(</mo><mrow><mi>a</mi><mo>+</mo><mi>b</mi><mi>i</mi></mrow><mo>)</mo></mrow><msup><mi>e</mi><mi>i</mi></msup><mo>,</mo><mrow><mo>(</mo><mrow><mi>c</mi><mo>+</mo><mi>d</mi><mi>i</mi></mrow><mo>)</mo></mrow><msup><mi>e</mi><mrow><mn>2</mn><mi>i</mi></mrow></msup><mo>,</mo><mrow><mo>(</mo><mrow><mi>f</mi><mo>+</mo><mi>g</mi><mi>i</mi></mrow><mo>)</mo></mrow><msup><mi>e</mi><mrow><mn>3</mn><mi>i</mi></mrow></msup></mrow><annotation encoding="TeX">\left(a+bi\right)e^{i} , \left(c+di\right)e^{2i} , \left(f+gi\right)e^{3i}   </annotation></semantics></math>etc.) and can be positive or negative.  A simple way of manually obtaining such coefficients (though not the best) is to use a graphing calculator.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Web Audio API', '#dom-baseaudiocontext-createperiodicwave', 'createPeriodicWave')}}</td>
			<td>{{Spec2('Web Audio API')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.BaseAudioContext.createPeriodicWave")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
